// SceneGraph.cpp: implementation of the SceneGraph class.
//
//////////////////////////////////////////////////////////////////////

#include "SceneGraph.h"
#include "SceneObject.h"
#include <vector>
#include <iostream>

SceneGraph::SceneGraph() {}

SceneGraph::~SceneGraph() {}

void SceneGraph::updateScene(SceneObject* sceneObject, float timeElapsed)
{
	if (!sceneObject) 
	{ 
		std::cerr << "Attempt update of object not on the scene graph.";
		return;
	}
	else
	{
		sceneObject->update(timeElapsed);
		// and call all the children
		std::vector<SceneObject*>::iterator it = 
                 sceneObject->getChildrenObjects()->begin();
		for (; it!=sceneObject->getChildrenObjects()->end(); ++it)
		{
			updateScene(*it, timeElapsed);
		}
	}
}

void SceneGraph::renderScene(SceneObject* sceneObject, float timeElapsed)
{
	if (!sceneObject) 
	{ 
		std::cerr << "Attempt update of object not on the scene graph.";
		return;
	}
	else
	{
		sceneObject->render(timeElapsed);
		// and call all the children
		std::vector<SceneObject*>::iterator it = 
                 sceneObject->getChildrenObjects()->begin();
		for (; it!=sceneObject->getChildrenObjects()->end(); ++it)
		{
			renderScene(*it, timeElapsed);
		}
	}
}
