
#include "LOD.h"
#include <iostream>

LOD::LOD()
{
    rangeList = new std::vector<Range>;
    selectedChild = NULL;
}

LOD::~LOD() {}

void LOD::addChild(SceneObject* child, float range)
{
    Range r(child, range);
    rangeList->push_back(r);
    selectedChild = child;
}

void LOD::render(float timeElapsed)
{
    selectedChild->render(timeElapsed);
}

void LOD::postRender(float timeElapsed)
{
    selectedChild->postRender(timeElapsed);
}

void LOD::update(float timeElapsed)
{ 
    std::cout << "Updating a LOD " << std::endl; 
    selectedChild->update(timeElapsed);
}

void LOD::switchChild(float distance)
{
    float curDist = 999999.0f; 
    for(int i=0; i<rangeList->size(); i++)
    {
       // find object with smallest r that is greater than distance
       Range range = rangeList->at(i);
       float r = range.getRange();     
       SceneObject *o = range.getChild();
       if ((r <= curDist) && ( r >= distance))
       {
          curDist = r;
          selectedChild = o;
       }
    }    
}
