// LOD.h 
//////////////////////////////////////////////////////////////////////

#if !defined LOD_H
#define LOD_H

#include "SceneObject.h"
#include <string>
#include <vector>

class Range
{
       float range;
       SceneObject* child;  
    public:
       Range(SceneObject* s, float r) { child = s; range = r; } 
       float getRange() { return range; }
       SceneObject* getChild() { return child; }   
};


class LOD : public SceneObject
{
private:
    std::vector<Range> *rangeList;
    SceneObject *selectedChild; 

public:
	LOD();
	virtual ~LOD();
	virtual RTTI_OBJECT_TYPE getType() const { return RTTI_LOD; }
    void addChild(SceneObject* child, float range);

	// Force every child to have a render and update methods
	virtual void render(float timeElapsed);
	virtual void postRender(float timeElapsed);
	virtual void update(float timeElapsed);
	virtual void switchChild(float distance);
};

#endif // LOD_H
