// Model.h -  This is a wrapper for the 3DS model class
//////////////////////////////////////////////////////////////////////

#if !defined MODEL_H
#define MODEL_H

#include "SceneObject.h"
#include "Model_3DS.h"
#include <string>

class Model : public SceneObject
{
      
private:
    Model_3DS *model;

public:
	Model(const std::string);
	virtual ~Model();

	virtual RTTI_OBJECT_TYPE getType() const { return RTTI_MODEL; }
	virtual Model_3DS* getModel() { return model; }
    
	// Force every child to have a render and update methods
	virtual void render(float timeElapsed);
	virtual void update(float timeElapsed);

};

#endif // MODEL_H
