
#include "Material.h"
#include "gl/gl.h"

Material::Material()
{
    ambient = Vec4(0.11f, 0.06f, 0.11f, 1.0f);
    diffuse = Vec4(0.43f, 0.47f, 0.54f, 1.0f);
    specular = Vec4(0.33f, 0.33f, 0.52f, 1.0f);
    emission = Vec4(0.00f, 0.00f, 0.00f, 0.0f);
    shininess = 10;
}

Material::~Material() {}

void Material::render(float timeElapsed)
{
     glMaterialfv(GL_FRONT, GL_AMBIENT, ambient.ptr());
     glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse.ptr());
     glMaterialfv(GL_FRONT, GL_SPECULAR, specular.ptr());
     glMaterialfv(GL_FRONT, GL_EMISSION, emission.ptr());
     glMaterialfv(GL_FRONT, GL_SHININESS, &shininess);
}

void Material::update(float timeElapsed)
{ 
     std::cout << "Updating a Material " << std::endl; 
}

